// Code generated by tablegen. DO NOT EDIT.
package tables

func (t AllTables) UserStreakEvents() UserStreakEvents { return UserStreakEvents(t) }

type UserStreakEvents struct{ alias string }

func (t UserStreakEvents) TableAlias() string { return t.alias }
func (t UserStreakEvents) name() string       { return "UserStreakEvents" }
func (t UserStreakEvents) TableName() string  { return tableName(t.name(), "", t.alias) }
func (t UserStreakEvents) AllColumnNames() []string {
	c := t.Columns()
	return []string{
		c.EventID(),
		c.StreakID(),
		c.UserStreakID(),
	}
}

func (t UserStreakEvents) Columns() UserStreakEventsCols {
	return UserStreakEventsCols{tableAlias: t.alias}
}

type UserStreakEventsCols struct{ tableAlias string }

func (c UserStreakEventsCols) EventID() string      { return colName(c.tableAlias, "EventID") }      // STRING(36)
func (c UserStreakEventsCols) StreakID() string     { return colName(c.tableAlias, "StreakID") }     // STRING(36)
func (c UserStreakEventsCols) UserStreakID() string { return colName(c.tableAlias, "UserStreakID") } // STRING(36)

func (t UserStreakEvents) Indexes() UserStreakEventsIndexes { return UserStreakEventsIndexes{table: t} }

type UserStreakEventsIndexes struct{ table UserStreakEvents }

func (i UserStreakEventsIndexes) ByEventIDUserStreakID() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "UserStreakEvents_EventID_UserStreakID",
		columns: []string{
			c.EventID(),
			c.StreakID(),
			c.UserStreakID(),
		},
	}
}
